package nc.bs.pu.m21.pfxx;

import nc.bs.framework.common.NCLocator;
import nc.bs.pu.m21.maintain.OrderSaveBP;
import nc.bs.pu.m21.maintain.rule.SupplierFrozeChkRule;
import nc.bs.pu.m21.plugin.OrderPluginPoint;
import nc.impl.pu.m21.action.OrderDeleteAction;
import nc.impl.pu.m21.action.rule.approve.ApproveAfterEventRule;
import nc.impl.pu.m21.action.rule.approve.ApproveBeforeEventRule;
import nc.impl.pu.m21.action.rule.approve.ApproveBudgetCtrlRule;
import nc.impl.pu.m21.action.rule.approve.ApproveSupplyRule;
import nc.impl.pu.m21.action.rule.approve.ApproveVOValidateRule;
import nc.impl.pu.m21.action.rule.approve.FillNcaninnumRule;
import nc.impl.pu.m21.action.rule.approve.FilterOrderByStatusRule;
import nc.impl.pu.m21.action.rule.approve.InsertPayPlanRule;
import nc.impl.pu.m21.action.rule.approve.InsertStatusOnWayRule;
import nc.impl.pubapp.pattern.data.bill.BillQuery;
import nc.impl.pubapp.pattern.rule.processer.AroundProcesser;
import nc.itf.pu.m21.IOrderApprove;
import nc.itf.pu.m21.IOrderMaintain;
import nc.itf.scmpub.reference.uap.bd.vat.BuySellFlagEnum;
import nc.itf.uap.pf.IPFBusiAction;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.pubitf.pu.m21.api.IOrderMaintainAPI;
import nc.vo.ml.NCLangRes4VoTransl;
import nc.vo.pu.m21.context.OrderContext;
import nc.vo.pu.m21.entity.OrderHeaderVO;
import nc.vo.pu.m21.entity.OrderItemVO;
import nc.vo.pu.m21.entity.OrderVO;
import nc.vo.pu.pfxx.plugins.AbstractPuPfxxPlugin;
import nc.vo.pu.pub.enumeration.POEnumBillStatus;
import nc.vo.pu.pub.enumeration.PuBusiLogActionCode;
import nc.vo.pu.pub.enumeration.PuBusiLogPathCode;
import nc.vo.pu.pub.rule.busilog.WriteOperateLogRule;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.compiler.PfParameterVO;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.pf.workflow.IPFActionName;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.scmf.pub.util.BatchNCBaseTypeUtils;
import org.apache.commons.lang.ArrayUtils;

public class M21PfxxPlugin extends AbstractPuPfxxPlugin {
	private void checkMny(AggregatedValueObject vo) {
		StringBuilder errrows = new StringBuilder();
		OrderItemVO[] bodyvos = ((OrderVO) vo).getBVO();
		OrderItemVO[] arr$ = bodyvos;
		int len$ = bodyvos.length;

		for (int i$ = 0; i$ < len$; ++i$) {
			OrderItemVO orderItemVO = arr$[i$];
			Integer fbuysellflag = orderItemVO.getFbuysellflag();
			UFDouble nmny = orderItemVO.getNmny();
			UFDouble ntaxmny = orderItemVO.getNtaxmny();
			UFDouble ntax = orderItemVO.getNtax();
			if (BuySellFlagEnum.IMPORT.value().equals(fbuysellflag)) {
				if (!nmny.equals(ntaxmny)) {
					errrows.append(orderItemVO.getCrowno() + ",");
				}
			} else if (BuySellFlagEnum.NATIONAL_BUY.value().equals(fbuysellflag)) {
				if (!nmny.add(ntax).equals(ntaxmny)) {
					errrows.append(orderItemVO.getCrowno() + ",");
				}
			} else {
				ExceptionUtils.wrappBusinessException(NCLangRes4VoTransl.getNCLangRes().getStrByID("4004000_0",
						"04004000-0139", (String) null, new String[]{orderItemVO.getCrowno()}));
			}
		}

		if (errrows.length() > 0) {
			errrows.deleteCharAt(errrows.length() - 1);
			ExceptionUtils.wrappBusinessException(NCLangRes4VoTransl.getNCLangRes().getStrByID("4004000_0",
					"04004000-0137", (String) null, new String[]{errrows.toString()}));
		}
	}

	private void checkRwite(AggregatedValueObject vo) {
		OrderItemVO[] bodyvos = ((OrderVO) vo).getBVO();
		OrderItemVO[] arr$ = bodyvos;
		int len$ = bodyvos.length;

		for (int i$ = 0; i$ < len$; ++i$) {
			OrderItemVO orderItemVO = arr$[i$];
			StringBuilder errstr = new StringBuilder();
			UFDouble nacccancelinvmny = orderItemVO.getNacccancelinvmny();
			if (!BatchNCBaseTypeUtils.isNullOrZero(nacccancelinvmny)) {
				errstr.append("nacccancelinvmny,");
			}

			UFDouble naccuminvoicemny = orderItemVO.getNaccuminvoicemny();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccuminvoicemny)) {
				errstr.append("naccuminvoicemny,");
			}

			UFDouble nfeemny = orderItemVO.getNfeemny();
			if (!BatchNCBaseTypeUtils.isNullOrZero(nfeemny)) {
				errstr.append("nfeemny,");
			}

			UFDouble naccumarrvnum = orderItemVO.getNaccumarrvnum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccumarrvnum)) {
				errstr.append("naccumarrvnum,");
			}

			UFDouble naccumstorenum = orderItemVO.getNaccumstorenum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccumstorenum)) {
				errstr.append("naccumstorenum,");
			}

			UFDouble naccuminvoicenum = orderItemVO.getNaccuminvoicenum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccuminvoicenum)) {
				errstr.append("naccuminvoicenum,");
			}

			UFDouble naccumwastnum = orderItemVO.getNaccumwastnum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccumwastnum)) {
				errstr.append("naccumwastnum,");
			}

			UFDouble naccumrpnum = orderItemVO.getNaccumrpnum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccumrpnum)) {
				errstr.append("naccumrpnum,");
			}

			UFDouble naccumdevnum = orderItemVO.getNaccumdevnum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccumdevnum)) {
				errstr.append("naccumdevnum,");
			}

			UFDouble nbackarrvnum = orderItemVO.getNbackarrvnum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(nbackarrvnum)) {
				errstr.append("nbackarrvnum,");
			}

			UFDouble nbackstorenum = orderItemVO.getNbackstorenum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(nbackstorenum)) {
				errstr.append("nbackstorenum,");
			}

			if (errstr.length() <= 0) {
				return;
			}

			errstr.deleteCharAt(errstr.length() - 1);
			ExceptionUtils.wrappBusinessException(NCLangRes4VoTransl.getNCLangRes().getStrByID("4004000_0",
					"04004000-0138", (String) null, new String[]{orderItemVO.getCrowno(), errstr.toString()}));
		}

	}

	private AggregatedValueObject save(AggregatedValueObject updatevo, AggregatedValueObject origVO) {
		OrderVO[] returnVOs = (new OrderSaveBP(new OrderContext())).save(new OrderVO[]{(OrderVO) updatevo},
				new OrderVO[]{(OrderVO) origVO});
		return returnVOs[0];
	}

	protected void checkCanInster(AggregatedValueObject vo) {
		OrderVO order = (OrderVO) vo;
		int status = order.getHVO().getForderstatus();
		if (POEnumBillStatus.APPROVE.toInt() == status) {
			String approver = order.getHVO().getApprover();
			if (approver == null || approver.isEmpty()) {
				ExceptionUtils.wrappBusinessException("ʧܣ̬ݲûˣ");
			}

			UFDate ufDate = order.getHVO().getTaudittime();
			if (ufDate == null) {
				ExceptionUtils.wrappBusinessException("ʧܣ̬ڲΪգ");
			}

			this.checkMny(vo);
		} else {
			super.checkCanInster(vo);
			this.checkMny(vo);
			this.checkRwite(vo);
		}

	}

	protected void deleteVO(AggregatedValueObject vo) {
		(new OrderDeleteAction()).delete(new OrderVO[]{(OrderVO) vo}, (OrderContext) null);
	}

	protected String getBillStatusKey() {
		return "forderstatus";
	}

	protected String getChildrenPkFiled() {
		return "pk_order_b";
	}

	protected String getParentPkFiled() {
		return "pk_order";
	}

	protected AggregatedValueObject insert(AggregatedValueObject vo) {
		OrderVO orderVO;
		
		if (vo != null) {
			this.checkCanInster(vo);
		}

		OrderVO order = (OrderVO) vo;
		int status = order.getHVO().getForderstatus();
		if (POEnumBillStatus.APPROVE.toInt() == status) {
			OrderHeaderVO hvo = order.getHVO();
			String approver = hvo.getApprover();
			hvo.setApprover((String) null);
			hvo.setForderstatus(POEnumBillStatus.FREE.toInt());
			UFDate taudittime = hvo.getTaudittime();
			hvo.setTaudittime((UFDate) null);
			AggregatedValueObject save = this.save(vo, (AggregatedValueObject) null);
			orderVO = this.approve(save, approver, taudittime);
			return orderVO;
		} else {
//			orderVO = (OrderVO) this.save(vo, (AggregatedValueObject) null);
			IPFBusiAction service = NCLocator.getInstance().lookup(IPFBusiAction.class);
			try {
//				service.processAction(IPFActionName.APPROVE,
//				     "21", null, orderVO, null, null);
				
				IMDPersistenceQueryService service2=NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
				OrderVO finProdInVO=(OrderVO) service2.queryBillOfNCObjectByPKWithDR(OrderVO.class,"1001ZZ1000000000RWWQ",true).getContainmentObject();
				
				NCLocator.getInstance().lookup(IOrderMaintain.class).delete(new OrderVO[] {finProdInVO},null);
			} catch (BusinessException e) {
				// TODO Զɵ catch 
				e.printStackTrace();
			}
			return null;
					
		}
	}

	private OrderVO approve(AggregatedValueObject vo, String approver, UFDate taudittime) {
		AroundProcesser<OrderVO> processer = new AroundProcesser(OrderPluginPoint.APPROVE);
		OrderVO order = (OrderVO) vo;
		this.addBeforeRule(processer);
		this.addAfterRule(processer);
		processer.before(new OrderVO[]{order});
		OrderHeaderVO hvo = order.getHVO();
		hvo.setApprover(approver);
		hvo.setForderstatus(POEnumBillStatus.APPROVE.toInt());
		hvo.setTaudittime(taudittime);
		processer.after(new OrderVO[]{order});
		return order;
	}

	private void addBeforeRule(AroundProcesser<OrderVO> processer) {
		processer.addBeforeRule(new ApproveVOValidateRule());
		processer.addBeforeRule(new SupplierFrozeChkRule());
		processer.addBeforeRule(new ApproveBeforeEventRule());
	}

	private void addAfterRule(AroundProcesser<OrderVO> processer) {
		processer.addAfterRule(new WriteOperateLogRule(PuBusiLogPathCode.orderApprovePath.getCode(),
				PuBusiLogActionCode.approve.getCode()));
		processer.addAfterRule(new FilterOrderByStatusRule(POEnumBillStatus.APPROVE.toInt()));
		processer.addAfterRule(new ApproveSupplyRule());
		processer.addAfterRule(new ApproveBudgetCtrlRule());
		processer.addAfterRule(new InsertStatusOnWayRule());
		processer.addAfterRule(new InsertPayPlanRule());
		processer.addAfterRule(new FillNcaninnumRule());
		processer.addAfterRule(new ApproveAfterEventRule());
	}

	protected AggregatedValueObject queryVOByPk(String voPk) {
		BillQuery<OrderVO> billquery = new BillQuery(OrderVO.class);
		OrderVO[] vos = (OrderVO[]) billquery.query(new String[]{voPk});
		return ArrayUtils.isEmpty(vos) ? null : vos[0];
	}

	protected AggregatedValueObject update(AggregatedValueObject updatevo, AggregatedValueObject origVO) {
		return this.save(updatevo, origVO);
	}
}